<?php
/*
Plugin Name: Automatic Newsletter
Plugin URI: http://craigfarnes.co.uk/
Description: Automaticly send a newsletter daily,weekly or monthly.
Author: Craig Farnes
Version: 1.2
Author URI: http://craigfarnes.co.uk/
*/
register_activation_hook(__FILE__,'autostart');


function autostart () {
   global $wpdb;

   $table_name = "wp_newsdates";
   if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
      
      $sql = "CREATE TABLE " . $table_name . " (
	  nextdate TEXT NOT NULL
	  
	);";
	
      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sql);
		
     }
	 $nextweek = date("W")+1;
		if($nextweek > 52) $nextweek=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextweek), array( '%s' ));


	 $table_name = "wp_newsoptions";
  if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
      
      $sql = "CREATE TABLE " . $table_name . " (
	  id mediumint(9) NOT NULL AUTO_INCREMENT,
	  often text NOT NULL,
	  value text NOT NULL,
	  UNIQUE KEY id (id)
	);";
	
      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sql);
		
     }
echo "hi";
                $wpdb->query("TRUNCATE wp_newsoptions");
                $wpdb->query('INSERT INTO wp_newsoptions  VALUES(1,"often","weekly")');
                $wpdb->query('INSERT INTO wp_newsoptions  VALUES(2,"recent","5")');
		
	  
	  $table_name = "wp_newsletteremails";
  if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
      
      $sql = "CREATE TABLE " . $table_name . " (
	  email text NOT NULL
	  
	);";
	
      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sql);
     }
}

function sendnewsletter($number){
global $wpdb;
$wpdb->show_errors();
$posts = get_posts("numberposts=$number");
$message= "";
foreach($posts as $post){
	$title=$post->post_title;
	$content2=$post->post_content;
	//$content2=substr($content,0,500);
    $message = $message."<b>".$title."</b><br />".$content2."<br />";
}



// In case any of our lines are larger than 70 characters, we should use wordwrap()
$message = wordwrap($message, 70);

// Send
$emailsn = $wpdb->get_var("SELECT COUNT(*) FROM wp_newsletteremails");
//echo $emailsn;
$j=0;
$homefind=$wpdb->get_row("SELECT * FROM wp_options WHERE option_id=3");
$home = $homefind->option_value;
//echo $home;
while($emailsn != $j){
$emails = $wpdb->get_row("SELECT * FROM wp_newsletteremails",OBJECT,$j);
$email = $emails->email;
//echo $email;
mail($email, 'Newsletter', $message,"To: The Receiver <$email>\n" .   
    "From: $home \n".
    "MIME-Version: 1.0\n" .   
    "Content-type: text/html; charset=iso-8859-1");
$j++;
}
}

function widget_newsletter() {
global $wpdb;
?>
<h2>Newsletter</h2><br />
<form action="" method="POST">
Email:<input name="email"><br />
<input type="submit" name="submit">
</form>
<?php
if(isset($_POST['submit'])){
	
	$wpdb->insert( 'wp_newsletteremails', array( 'email' => $_POST['email']), array('%s') );
	echo "Email Added, Thank you";
}
}
function newsletter_init()
{
  register_sidebar_widget(__('Newsletter'), 'widget_newsletter');     
}
add_action("plugins_loaded", "newsletter_init");




add_action('admin_menu', 'autonewspage');
function autonewspage(){
	add_options_page('options-general.php','Automatic Newsletter Settings','administrator','autonews','autonewsdisplay');
}
function autonewsdisplay() {
global $wpdb;
$wpdb->show_errors();
$get = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=2");
$recent = $get->value;
?>
<form action="" method="POST">
How often to send newsletters:<select name="often"><option value="Daily">Daily</option><option value="weekly">Weekly</option><option value="Monthly">Monthly</option></select><br />
<input type="submit" name="often2" value="save"><br />
</form>
<form action="" method="POST">
Number of recent posts to email:<input value="<?php echo $recent; ?>" name="recent"><br />
<input type="submit" name="submit" value="Save" >
</form>
<form action="" method="POST">
<input type="submit" name="send" value="Send a Newsletter Now">
</form>
<?php
if(isset($_POST['often2'])){
	//$wpdb->query("TRUNCATE wp_newsoptions");
         $often=$_POST['often'];
         $wpdb->query("UPDATE wp_newsoptions SET value='$often' WHERE id= 1");
	
	
	
	$when = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=1");
	$number = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=2");
	$number = $number->value;
	$next = $wpdb->get_row("SELECT * FROM wp_newsdates");
	$next = $next->nextdate;
	$when=$_POST['often'];
	if($when=="Daily"){
		
			//add check if over days of the month etc
			$wpdb->query("TRUNCATE wp_newsdates");
			$nextday = date("j")+1;
			$month = date("n");
			switch ($month){
				case 1:
				$days=31;
				break;
				
				case 2:
				$days=28;
				break;
				
				case 3:
				$days=31;
				break;
				
				case 4:
				$days=30;
				break;
				
				case 5:
				$days=31;
				break;
				
				case 6:
				$days=30;
				break;
				
				case 7:
				$days=31;
				break;
				
				case 8:
				$days=31;
				break;
				
				case 9:
				$days=30;
				break;
				
				case 10:
				$days=31;
				break;
				
				case 11:
				$days=30;
				break;
				
				case 12:
				$days=31;
				break;
			}
			if($nextday > $days){
			$nextday = 1;
			}
			$wpdb->insert('wp_newsdates',array('nextdate' => $nextday), array( '%s' ));
		}
		
	
	if($when=="weekly"){
		//echo date("W");
		
		$nextweek = date("W")+1;
		if($nextweek > 52) $nextweek=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextweek), array( '%s' ));
	}
	if($when=="Monthly"){
		
		$nextmonth = date("n")+1;
		if($nextmonth > 12) $nextmonth=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextmonth), array( '%s' ));
	}
	
	
	
	echo "Saved";
}
if(isset($_POST['submit'])){
	//$wpdb->query("TRUNCATE wp_newsoptions");
	$often=$_POST['recent'];
         $wpdb->query("UPDATE wp_newsoptions SET value='$often' WHERE id= 2");
	echo "Saved";
}
if(isset($_POST['send'])){
	sendnewsletter($recent);
	echo "Sent!";
}
}


add_action( is_admin() ? 'admin_head' : 'wp_head', 'load_into_head212' ); 
function load_into_head212() {  
	global $wpdb;
	$wpdb->show_errors();
	$when = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=1");
	$number = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=2");
	$number = $number->value;
	$next = $wpdb->get_row("SELECT * FROM wp_newsdates");
	$next = $next->nextdate;
	$when=$when->value;
	if($when=="Daily"){
		if(date("j")>=$next){
			sendnewsletter($number);
			//add check if over days of the month etc
			$wpdb->query("TRUNCATE wp_newsdates");
			$nextday = date("j")+1;
			$month = date("n");
			switch ($month){
				case 1:
				$days=31;
				break;
				
				case 2:
				$days=28;
				break;
				
				case 3:
				$days=31;
				break;
				
				case 4:
				$days=30;
				break;
				
				case 5:
				$days=31;
				break;
				
				case 6:
				$days=30;
				break;
				
				case 7:
				$days=31;
				break;
				
				case 8:
				$days=31;
				break;
				
				case 9:
				$days=30;
				break;
				
				case 10:
				$days=31;
				break;
				
				case 11:
				$days=30;
				break;
				
				case 12:
				$days=31;
				break;
			}
			if($nextday > $days){
			$nextday = 1;
			}
			$wpdb->insert('wp_newsdates',array('nextdate' => $nextday), array( '%s' ));
		}
		}
	
	if($when=="weekly"){
		//echo date("W");
		if($next == date("W")){
			sendnewsletter($number);
		}
		$nextweek = date("W")+1;
		if($nextweek > 52) $nextweek=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextweek), array( '%s' ));
	}
	if($when=="Monthly"){
		if($next == date("n")){
			sendnewsletter($number);
		}
		$nextmonth = date("n")+1;
		if($nextmonth > 12) $nextmonth=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextmonth), array( '%s' ));
	}
}
?>